package org.wfc.omada.api.device.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.Pattern;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * EasyManagedSwitchGeneralConfig
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:26:25.576+08:00[Asia/Shanghai]")

public class EasyManagedSwitchGeneralConfig   {
  @JsonProperty("name")
  private String name;

  @JsonProperty("ledSetting")
  private Integer ledSetting;

  @JsonProperty("tagIds")
  @Valid
  private List<String> tagIds = null;

  @JsonProperty("jumboEnable")
  private Boolean jumboEnable;

  @JsonProperty("location")
  private DeviceLocationDetailVo location;

  @JsonProperty("remember")
  private Boolean remember;

  public EasyManagedSwitchGeneralConfig name(String name) {
    this.name = name;
    return this;
  }

  /**
   * Device name should contain 1 to 32 characters.
   * @return name
  */
  @ApiModelProperty(value = "Device name should contain 1 to 32 characters.")

@Pattern(regexp="^[^ \\+\\-\\@\\=]$|^[^ \\+\\-\\@\\=].{0,30}[^ ]$") 
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public EasyManagedSwitchGeneralConfig ledSetting(Integer ledSetting) {
    this.ledSetting = ledSetting;
    return this;
  }

  /**
   * LED setting should be a value as follows: 0:off; 1:on; 2:Use Site Settings
   * @return ledSetting
  */
  @ApiModelProperty(value = "LED setting should be a value as follows: 0:off; 1:on; 2:Use Site Settings")


  public Integer getLedSetting() {
    return ledSetting;
  }

  public void setLedSetting(Integer ledSetting) {
    this.ledSetting = ledSetting;
  }

  public EasyManagedSwitchGeneralConfig tagIds(List<String> tagIds) {
    this.tagIds = tagIds;
    return this;
  }

  public EasyManagedSwitchGeneralConfig addTagIdsItem(String tagIdsItem) {
    if (this.tagIds == null) {
      this.tagIds = new ArrayList<>();
    }
    this.tagIds.add(tagIdsItem);
    return this;
  }

  /**
   * Tag IDs
   * @return tagIds
  */
  @ApiModelProperty(value = "Tag IDs")


  public List<String> getTagIds() {
    return tagIds;
  }

  public void setTagIds(List<String> tagIds) {
    this.tagIds = tagIds;
  }

  public EasyManagedSwitchGeneralConfig jumboEnable(Boolean jumboEnable) {
    this.jumboEnable = jumboEnable;
    return this;
  }

  /**
   * Parameter [jumboEnable] should be true or false.
   * @return jumboEnable
  */
  @ApiModelProperty(value = "Parameter [jumboEnable] should be true or false.")


  public Boolean getJumboEnable() {
    return jumboEnable;
  }

  public void setJumboEnable(Boolean jumboEnable) {
    this.jumboEnable = jumboEnable;
  }

  public EasyManagedSwitchGeneralConfig location(DeviceLocationDetailVo location) {
    this.location = location;
    return this;
  }

  /**
   * Get location
   * @return location
  */
  @ApiModelProperty(value = "")

  @Valid

  public DeviceLocationDetailVo getLocation() {
    return location;
  }

  public void setLocation(DeviceLocationDetailVo location) {
    this.location = location;
  }

  public EasyManagedSwitchGeneralConfig remember(Boolean remember) {
    this.remember = remember;
    return this;
  }

  /**
   * Parameter [remember] should be true or false.
   * @return remember
  */
  @ApiModelProperty(value = "Parameter [remember] should be true or false.")


  public Boolean getRemember() {
    return remember;
  }

  public void setRemember(Boolean remember) {
    this.remember = remember;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    EasyManagedSwitchGeneralConfig easyManagedSwitchGeneralConfig = (EasyManagedSwitchGeneralConfig) o;
    return Objects.equals(this.name, easyManagedSwitchGeneralConfig.name) &&
        Objects.equals(this.ledSetting, easyManagedSwitchGeneralConfig.ledSetting) &&
        Objects.equals(this.tagIds, easyManagedSwitchGeneralConfig.tagIds) &&
        Objects.equals(this.jumboEnable, easyManagedSwitchGeneralConfig.jumboEnable) &&
        Objects.equals(this.location, easyManagedSwitchGeneralConfig.location) &&
        Objects.equals(this.remember, easyManagedSwitchGeneralConfig.remember);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, ledSetting, tagIds, jumboEnable, location, remember);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class EasyManagedSwitchGeneralConfig {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    ledSetting: ").append(toIndentedString(ledSetting)).append("\n");
    sb.append("    tagIds: ").append(toIndentedString(tagIds)).append("\n");
    sb.append("    jumboEnable: ").append(toIndentedString(jumboEnable)).append("\n");
    sb.append("    location: ").append(toIndentedString(location)).append("\n");
    sb.append("    remember: ").append(toIndentedString(remember)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

